******************************************************************
**								**
**	tcc - text color changer				**
**								**
**	[description]	text color  change 			**
**	[version]	1.03.01					**
**	[author]	Ö(Tsunami)				**
**								**
******************************************************************


.include	doscall.mac
.include	iocscall.mac
.include	window.h

.xref		_openwin,_closewin

setdstrreg	reg		d0/a3			*  setdstr gp register
hssetreg	reg		a0/a3			*  hsset_? gp register
htoszreg	reg		d0-d3/a1		*  htosz?f gp register

							* [ window parameter ]
x_size		equ		dstr_end-dstr+6		*  x  size (character P)
w_color		equ		1			*  window color (1 or 2)
h_x1		equ		(x_size-h_size)/2	*  header Jn x W (x1 )
h_size		equ		test_head_end-test_head	*  header size
buffsize	equ		((x_size*16)*20)*2	*  ޔ buffer size

.text

							* Initialize -------------------
		lea		usersp,sp
		lea		work,a6			*  a6: work pointer
		movea.l		a0,a3			*  a3: &PSP
		lea		$10(a0),a0
		suba.l		a0,a1
		pea		(a1)
		pea		(a0)
		DOS		_SETBLOCK
		addq.l		#8,sp
		moveq.l		#6-1,d5			*  d5.w: counter l
							*     6-1: normal mode
							*    16-1: extend mode
		moveq.l		#-1,d6			*  d6.b: option flag 1
							*    -1: -C/d/D/t/T ǂłȂ
							*     0: -C ł
							*     1: -d/D ł
							*     2: -t/T ł
		sf		d7			*  d7.b: option flag 2
							*     0: normal mode
							*    -1: extend mode
		lea		palntbl(pc),a5		*  a5: &(pallet no. table)
		lea		$c4(a3),a0		*  make messhead
		lea		messhead(a6),a1
		bsr		catstr
		lea		messheadp(pc),a0
		bsr		catstr
		move.w		#16-1,d3		*  initialize text pallet work
		lea		tpalwork(a6),a0		*    -D p
@@:		move.l		#-1,(a0)+
		dbf		d3,@b
*
							* Check parameters -------------
		tst.b		(a2)+			*  parameter Ȃ ?
		beq		gete			*  yes: get $TCOLOR
		cmpi.b		#'-',(a2)
		bne		chks			*  option Ȃ: check string
		cmpi.b		#'C',1(a2)		*  -C ?
		bne		chkprm1			*  no
		moveq.l		#16-1,d5		*  -C: change (extend mode)
		sf		d6
		moveq.l		#-1,d7
		lea		palntblex(pc),a5
		tst.b		2(a2)			*  option  ?
		beq		gete			*  yes: get $TCOLOREX
		addq.l		#1,a2			*  skip ' ' & TAB
@@:		addq.l		#1,a2
		cmpi.b		#' ',(a2)
		beq		@b
		cmpi.b		#$09,(a2)
		beq		@b
		bra		chks
chkprm1:	tst.b		2(a2)			*  option  ?
		bne		error1			*  no: parameter error
		cmpi.b		#'h',1(a2)
		beq		usage			*  -h: usage
		cmpi.b		#'i',1(a2)
		beq		inittp			*  -i: initialize
		cmpi.b		#'d',1(a2)		*  -d ?
		beq		chkprm2			*  yes
		cmpi.b		#'D',1(a2)		*  -D ?
		bne		chkprm3			*  no
		moveq.l		#-1,d7			*  -D: describe present values
							*      (extend mode)
chkprm2:	moveq.l		#1,d6			*  -d: describe present values
		bra		chkprmq
chkprm3:	cmpi.b		#'t',1(a2)		*  -t ?
		beq		chkprm4			*  yes
		cmpi.b		#'T',1(a2)		*  -T ?
		bne		error1			*  no: parameter error
		moveq.l		#-1,d7			*  -T: test (extend mode)
chkprm4:	moveq.l		#2,d6			*  -t: test
chkprmq:	tst.b		d7			*  normal mode ?
		beq		settp			*  yes
		moveq.l		#16-1,d5
		lea		palntblex(pc),a5
		bra		settp
*
							* Get $TCOLOR[EX] --------------
gete:		clr.b		envbuff(a6)
		pea		envbuff(a6)
		pea		0.w
		pea		envname1(pc)
		tst.b		d7			*  normal mode ?
		beq		gete1			*  yes
		addq.l		#4,sp			*  $TCOLOREX
		pea		envname2(pc)
gete1:		DOS		_GETENV
		lea		12(sp),sp
		lea		envbuff(a6),a2
*
							* Check string -----------------
chks:		movea.l		a5,a0			*  a0: &(text pallet no. table)
		lea		tpalwork(a6),a1		*  a1: &(text pallet work)
		move.w		d5,d3			*  d3: counter
chks0:		movea.l		a2,a3			*  a2: &(command line)
							*  a3: O check p work
							*      stoh 
chks1:		cmpi.b		#',',(a2)		*-- Search ',' or EOT
		beq		chks2			*  ',': ',' O check 
		tst.b		(a2)
		beq		chks4			*  EOT: EOT O check 
		addq.l		#1,a2			*  next character
		bra		chks1
chks2:		tst.w		d3			*-- ',' O check
		beq		error2			*  too many ',': color code error
		cmpa.l		a2,a3			*  Ȃ ?
		bne		chks3			*  no
		addq.l		#1,a2			*  only ','
		tst.b		(a2)			*  ',' ̌ɂȂ ?
		beq		settp			*  yes: quit
		bra		chks6			*  no: next
chks3:		clr.b		(a2)+			*  ','  EOT ɒu
		bra		chks5
chks4:		cmpa.l		a2,a3			*-- EOT O check
		beq		settp			*  Ȃ: quit
chks5:		bsr		stoh			*-- Check & set color code
		tst.l		d1
		bmi		error2			*  color code error
		cmpi.l		#$ffff,d0		*  color code > $ffff ?
		bgt		error2			*  yes: color code error
		move.w		(a0),d4			*  set
		add.w		d4,d4
		add.w		d4,d4
		move.l		d0,(a1,d4.w)
		tst.b		(a2)			*  I肩 ?
		beq		settp			*  yes: quit
chks6:		addq.l		#2,a0			*  next
		dbf		d3,chks0
		bra		settp
*
							* Initialize text pallet -------
inittp:		move.w		#16-1,d3
		lea		tpalwork(a6),a0
@@:		move.l		#-2,(a0)+
		dbf		d3,@b
*
							* Set text pallet --------------
settp:		movea.l		a5,a0			*  a0: &(text pallet no. table)
		lea		tpalwork(a6),a1		*  a1: &(text pallet work)
		lea		tpalsh(a6),a2		*  a2: &(text pallet ޔ area)
		move.w		d5,d3			*  d3: counter
settp1:		move.w		(a0)+,d1		*  d1: text pallet no.
		move.w		d1,d4			*  d4: work
		add.w		d4,d4
		add.w		d4,d4
		move.l		(a1,d4.w),d2		*  d2: color code
		tst.b		d7			*  normal mode ?
		beq		settp2			*  yes
		IOCS		_TPALET2
		bra		settp3
settp2:		IOCS		_TPALET
settp3:		move.l		d0,(a1,d4.w)		*  -d/D p
		move.l		d0,(a2,d4.w)		*  -t/T p
		dbf		d3,settp1		*  next
		cmpi.b		#2,d6			*  -t/T ?
		beq		test			*  yes: test
		cmpi.b		#1,d6			*  -d/D ?
		bne		quit			*  no: quit
*
							* Describe present values ------
		pea		dhead(pc)		*  describe header
		DOS		_PRINT
		pea		crlf(pc)
		DOS		_PRINT
		addq.l		#8,sp
		movea.l		a5,a0			*  a0: &(text pallet no. table)
		lea		tpalwork(a6),a1		*  a1: &(text pallet work)
		move.w		d5,d3			*  d3: counter
@@:		move.w		(a0)+,d1
		move.w		d1,d2
		add.w		d2,d2
		add.w		d2,d2
		move.l		(a1,d2.w),d2
		bsr		setdstr
		pea		dstr(pc)		*  describe
		DOS		_PRINT
		pea		crlf(pc)
		DOS		_PRINT
		addq.l		#8,sp
		dbf		d3,@b			*  next
		bra		quit
*
							*  x,y ő啝 table --------
x_width:	dc.w		64,64,0,0,64,64,0,0,64,64,0,0,64,64,0,0,96,128,128
y_width:	dc.w		32,32,0,0,32,32,0,0,32,32,0,0,32,32,0,0,32,26,52
*
							* Test -------------------------
							*-- open window
test:		clr.l		-(sp)			*  supervisor mode ֈڍs
		DOS		_SUPER
		move.l		#buffsize,-(sp)		*  ޔ buffer m
		DOS		_MALLOC
		addq.l		#8,sp
		tst.l		d0
		bmi		error3			*  memory error
		move.l		d0,buff_addr+win_str(a6)
		moveq.l		#-1,d1			*  CRT mode 擾
		IOCS		_CRTMOD
		cmpi.l		#$12,d0			*  CRT mode > $12 ?
		bhi		error4			*  yes: ΉĂȂ CRT mode
		add.l		d0,d0
		lea		test_head(pc),a0
		move.l		a0,header_addr+win_str(a6)
		move.w		x_width(pc,d0.l),d1	*  d1: Jn x W
		tst.w		d1			*  0 ?
		beq		error4			*  yes: ΉĂȂ CRT mode
		sub.w		#x_size,d1
		lsr.w		#1,d1
		move.w		d1,win_x1+win_str(a6)
		move.w		y_width(pc,d0.l),d2	*  d2: Jn y W
		move.w		d5,d3			*  d3: window ysize
		addi.w		#1+2+1+1,d3		*  header+㉺[+dhead+d5␳
		sub.w		d3,d2
		lsr.w		#1,d2
		move.w		d2,win_y1+win_str(a6)
		move.w		#x_size,win_xsize+win_str(a6)
		move.w		d3,win_ysize+win_str(a6)
		move.w		#w_color,win_color+win_str(a6)
		move.w		#h_x1,header_x1+win_str(a6)
		move.w		#h_size,header_size+win_str(a6)
		IOCS		_OS_CUROF
		pea		win_str(a6)
		bsr		_openwin
							*-- \
		addq.w		#2,d1
		addq.w		#2,d2
		IOCS		_B_LOCATE
		move.l		d0,d7			*  d7: cursor position ޔ
		lea		dhead(pc),a1
		IOCS		_B_PRINT
		lea		cr_1(pc),a1
		IOCS		_B_PRINT
		IOCS		_B_DOWN_S
		movea.l		a5,a0			*  a0: &(text pallet no. table)
		lea		tpalwork(a6),a2		*  a2: &(text pallet work)
		move.w		d5,d3			*  d3: counter
@@:		move.w		(a0)+,d1
		move.w		d1,d2
		add.w		d2,d2
		add.w		d2,d2
		move.l		(a2,d2.w),d2
		bsr		setdstr
		lea		dstr(pc),a1
		IOCS		_B_PRINT
		lea		cr_1(pc),a1		*  next line
		IOCS		_B_PRINT
		IOCS		_B_DOWN_S
		dbf		d3,@b
		move.w		d5,d1
		addq.b		#1,d1
		IOCS		_B_UP			*  pallet 0 \ʒuֈړ
		moveq.l		#0,d6			*  d6: current position
		bra		test1_1			*      0`5 or 0`15
							*-- Jg\
test1:		move.w		d6,d0			*  code \
		add.w		d0,d0
		move.w		(a5,d0.w),d1		*  d1: (current pallet no.)
		move.w		d1,d3			*  d3: d1*(1longword)
		add.w		d3,d3
		add.w		d3,d3
		move.l		tpalwork(a6,d3.w),d2	*  d2: current color
		bsr		setdstr
		lea		dstr(pc),a1
		IOCS		_B_PRINT
		lea		cr_1(pc),a1
		IOCS		_B_PRINT
		IOCS		_TPALET2
		bra		test2
test1_1:	lea		marker(pc),a1		*  marker \
		IOCS		_B_PRINT
		lea		cr_2(pc),a1
		IOCS		_B_PRINT
test1_2:	move.w		d6,d0
		add.w		d0,d0
		move.w		(a5,d0.w),d1
		move.w		d1,d3			*  d3: d1*(1longword)
		add.w		d3,d3
		add.w		d3,d3
		move.l		tpalwork(a6,d3.w),d2
							*-- Inkey
test2:		IOCS		_B_KEYINP
		lsr.w		#8,d0
		andi.b		#%0111_111,d0
		cmpi.b		#$1d,d0			*  [ENTER] ?
		beq		test2_b			*  yes: set pallet
		cmpi.b		#$4e,d0			*  [ENTER] ?
		beq		test2_b			*  yes: set pallet
		cmpi.b		#$01,d0			*  [ESC] ?
		beq		test2_c			*  yes: recover pallet
		cmpi.b		#$1e,d0			*  [A] ?
		beq		test2_4			*  yes: increment R
		cmpi.b		#$2a,d0			*  [Z] ?
		beq		test2_5			*  yes: decrement R
		cmpi.b		#$1f,d0			*  [S] ?
		beq		test2_6			*  yes: increment G
		cmpi.b		#$2b,d0			*  [X] ?
		beq		test2_7			*  yes: decrement G
		cmpi.b		#$20,d0			*  [D] ?
		beq		test2_8			*  yes: increment B
		cmpi.b		#$2c,d0			*  [C] ?
		beq		test2_9			*  yes: decrement B
		cmpi.b		#$21,d0			*  [F] ?
		beq		test2_a			*  yes: change I
		cmpi.b		#$3c,d0			*  [] ?
		beq		test2_2			*  yes: up marker
		cmpi.b		#$3e,d0			*  [] ?
		bne		test2			*  no
							*-- Down marker
		moveq.l		#1,d1			*  d1: IOCS _B_DOWN p
		cmp.w		d5,d6			*  ԉ ?
		bne		test2_1_1		*  no
		moveq.l		#0,d6			*  ԏ
		move.w		d5,d1
		bra		test2_2_2
test2_1_1:	addq.w		#1,d6			*  
test2_1_2:	lea		erase_marker(pc),a1	*  
		IOCS		_B_PRINT
		IOCS		_B_DOWN
		bra		test1_1			*  ĕ\
							*-- Up marker
test2_2:	moveq.l		#1,d1
		tst.w		d6			*  ԏ ?
		bne		test2_2_1		*  no
		move.w		d5,d6			*  ԉ
		move.w		d5,d1
		bra		test2_1_2
test2_2_1:	subq.w		#1,d6			*  
test2_2_2:	lea		erase_marker(pc),a1	*  
		IOCS		_B_PRINT
		IOCS		_B_UP
		bra		test1_1			*  ĕ\
							*-- Increment R
test2_4:	andi.l		#(%1_1111.shl.6),d2
		cmpi.l		#(%1_1111.shl.6),d2
		beq		test1_2
		addi.l		#(%1.shl.6),tpalwork(a6,d3.w)
		bra		test1
							*-- Decrement R
test2_5:	andi.l		#(%1_1111.shl.6),d2
		tst.l		d2
		beq		test1_2
		subi.l		#(%1.shl.6),tpalwork(a6,d3.w)
		bra		test1
							*-- Increment G
test2_6:	andi.l		#(%1_1111.shl.11),d2
		cmpi.l		#(%1_1111.shl.11),d2
		beq		test1_2
		addi.l		#(%1.shl.11),tpalwork(a6,d3.w)
		bra		test1
							*-- Decrement G
test2_7:	andi.l		#(%1_1111.shl.11),d2
		tst.l		d2
		beq		test1_2
		subi.l		#(%1.shl.11),tpalwork(a6,d3.w)
		bra		test1
							*-- Increment B
test2_8:	andi.l		#(%1_1111.shl.1),d2
		cmpi.l		#(%1_1111.shl.1),d2
		beq		test1_2
		addi.l		#(%1.shl.1),tpalwork(a6,d3.w)
		bra		test1
							*-- Decrement B
test2_9:	andi.l		#(%1_1111.shl.1),d2
		tst.l		d2
		beq		test1_2
		subi.l		#(%1.shl.1),tpalwork(a6,d3.w)
		bra		test1
							*-- Change I
test2_a:	bchg.l		#0,d2
		move.l		d2,tpalwork(a6,d3.w)
		bra		test1
							*-- Set pallet
test2_b:	lea		tpalwork(a6),a1
		bra		test2_d
							*-- Recover pallet
test2_c:	lea		tpalsh(a6),a1
							*-- Set or recover
test2_d:	movea.l		a5,a0			*  a0: &(text pallet no. table)
		move.w		d5,d3			*  d3: counter
@@:		move.w		(a0)+,d1		*  d1: text pallet no.
		move.w		d1,d0
		add.w		d0,d0
		add.w		d0,d0
		move.l		(a1,d0.w),d2		*  d2: color code
		IOCS		_TPALET2
		dbf		d3,@b			*  next
							*-- close window
		move.l		d7,d1
		move.w		d1,d2
		swap		d1
		IOCS		_B_LOCATE
		bsr		_closewin
		addq.l		#4,sp
		IOCS		_OS_CURON
		bra		quit
*
							* Usage ------------------------
usage:		pea		usmsg(pc)
		bra		pmsg1			*  messhead ͕tȂ
*
							* Error ------------------------
error1:		pea		errmsg1(pc)
		bra		pmsg
error2:		pea		errmsg2(pc)
		bra		pmsg
error3:		pea		errmsg3(pc)
		bra		pmsg
error4:		pea		errmsg4(pc)
*
pmsg:		pea		messhead(a6)
		DOS		_PRINT
		addq.l		#4,sp
pmsg1:		DOS		_PRINT
		addq.l		#4,sp
*
							* Quit -------------------------
quit:		DOS		_EXIT
*
*
							* (a0)`  (a1)` -------------
							*  [arg]  a0,a1
							*  [rtn]  a0: &EOT+1
							*         a1: &EOT
catstr:		move.b		(a0)+,(a1)+
		bne		catstr
		subq.l		#1,a1
		rts
*
*
							* l\̂߂̕ݒ -----
							*  [arg]  d1.w: pallet number
							*	  d2: color code
setdstr:	movem.l		setdstrreg,-(sp)
		move.w		d1,d0
		ext.l		d0
		lea		dpartsc(pc),a3		*  pallet no.
		bsr		hsset_1
		lea		dpartsh(pc),a3		*  color code
		move.l		d2,d0
		bsr		hsset_4
		lea		dpartsr(pc),a3		*  R 
		move.l		d2,d0
		lsr.w		#6,d0
		andi.w		#%11111,d0
		bsr		hsset_2
		lea		dpartsg(pc),a3		*  G 
		move.l		d2,d0
		lsr.w		#8,d0
		lsr.w		#3,d0
		andi.w		#%11111,d0
		bsr		hsset_2
		lea		dpartsb(pc),a3		*  B 
		move.l		d2,d0
		lsr.w		#1,d0
		andi.w		#%11111,d0
		bsr		hsset_2
		lea		dpartsi(pc),a3		*  I 
		move.l		d2,d0
		andi.w		#%1,d0
		bsr		hsset_1
		movem.l		(sp)+,setdstrreg
		rts
*
*
							* Convert string into HEX ------
							*  [arg]  a3: &string
							*  [rtn]  d0: number
							*	  d1: flag
							*	      0: normal quit
							*	     -1: error quit
							*	  a3: &EOT+1
stoh:		move.l		d2,-(sp)
		moveq.l		#0,d0
		moveq.l		#0,d1
		moveq.l		#0,d2
stoh1:		move.b		(a3)+,d2		*  get 1 character
		beq		stohq			*  EOT
		cmpi.b		#'0',d2
		bcs		stoherr			*  number error
		cmpi.b		#'9',d2
		bls		stoh3
		cmpi.b		#'A',d2
		bcs		stoherr			*  number error
		cmpi.b		#'F',d2
		bls		stoh2
		cmpi.b		#'a',d2
		bcs		stoherr			*  number error
		cmpi.b		#'f',d2
		bhi		stoherr			*  number error
		subi.b		#$20,d2
stoh2:		subi.b		#7,d2
stoh3:		subi.b		#'0',d2			*  *16+n
		lsl.l		#4,d0
		add.l		d2,d0
		bra		stoh1			*  next
stoherr:	moveq.l		#-1,d1			*  error quit
stohq:		move.l		(sp)+,d2
		rts
*
*
							* HTOS & set -------------------
							*  (4 )
							*  [arg]  d0: number
							*	  a3: &(set  buffer)
hsset_4:	movem.l		hssetreg,-(sp)
		lea		htosbuff(a6),a0
		bsr		htosz4f
		bra		hsset1
*
							* HTOS & set -------------------
							*  (2 )
							*  [arg]  d0: number
							*	  a3: &(set  buffer)
hsset_2:	movem.l		hssetreg,-(sp)
		lea		htosbuff(a6),a0
		bsr		htosz2f
		bra		hsset1
*
*
							* HTOS & set -------------------
							*  (1 )
							*  [arg]  d0: number
							*	  a3: &(set  buffer)
hsset_1:	movem.l		hssetreg,-(sp)
		lea		htosbuff(a6),a0
		bsr		htosz1f
*
hsset1:		lea		htosbuff(a6),a0		*  EOT ɂȂO܂ copy
hsset2:		move.b		(a0)+,(a3)+
		tst.b		(a0)
		bne		hsset2
		movem.l		(sp)+,hssetreg
		rts
*
*
							* Convert HEX into string ------
							*  (4 C[TvXȂ)
							*  [arg]  d0: number (4 ܂)
							*	  a0: &(i[ buffer)
							*  [rtn]  a0: &EOT
htosz4f:	movem.l		htoszreg,-(sp)
		lea		exhtos4(pc),a1		*  a1: exptable pointer
		moveq.l		#4-1,d1			*  d1: table counter
		bra		htosz1
*
							* Convert HEX into string ------
							*  (2 C[TvXȂ)
							*  [arg]  d0: number (2 ܂)
							*	  a0: &(i[ buffer)
							*  [rtn]  a0: &EOT
htosz2f:	movem.l		htoszreg,-(sp)
		lea		exhtos2(pc),a1		*  a1: exptable pointer
		moveq.l		#2-1,d1			*  d1: table counter
		bra		htosz1
*
							* Convert HEX into string ------
							*  (1 )
							*  [arg]  d0: number (1 ܂)
							*	  a0: &(i[ buffer)
							*  [rtn]  a0: &EOT
htosz1f:	movem.l		htoszreg,-(sp)
		lea		exhtos1(pc),a1		*  a1: exptable pointer
		sf		d1			*  d1: table counter
*
htosz1:		moveq.l		#'0',d2			*  d2: character work
		move.l		(a1)+,d3		*  d3: exponent work
htosz2:		sub.l		d3,d0			*  Ƃ܂ň
		bcs		htosz3
		addq.b		#1,d2
		bra		htosz2
htosz3:		add.l		d3,d0			*  C
		cmpi.b		#'9',d2			*  '9'  ?
		bls		htosz4			*  no
		addi.b		#7,d2			*  'A'`'F' ɏC
htosz4:		move.b		d2,(a0)+		*  o
		dbf		d1,htosz1		*  next
		clr.b		(a0)			*  EOT t
		movem.l		(sp)+,htoszreg
		rts
*
*


.data

exhtos4:	dc.l		$1000		*  exponent table for htos (4 figures)
		dc.l		$100
exhtos2:	dc.l		$10		*  exponent table for htos (2 figures)
exhtos1:	dc.l		$1		*  exponent table for htos (1 figures)
palntbl:	dc.w		0,1,2,3,4,8	*  text pallet no. table (normal)
palntblex:	dc.w		0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15	*  (extend)
messheadp:	dc.b		': ',0
envname1:	dc.b		'TCOLOR',0
envname2:	dc.b		'TCOLOREX',0
dhead:		dc.b		'          Code   R  G  B  I ',0
dstr:		dc.b		'pallet '
dpartsc:	dc.b		0
		dc.b		': '
dpartsh:	dc.b		0,0,0,0
		dc.b		'  ['
dpartsr:	dc.b		0,0
		dc.b		','
dpartsg:	dc.b		0,0
		dc.b		','
dpartsb:	dc.b		0,0
		dc.b		','
dpartsi:	dc.b		0
		dc.b		']',0
dstr_end:
test_head:	dc.b		' text color test '
test_head_end:
marker:		dcb.b		29,$0c
		dc.b		'',0
erase_marker:	dcb.b		29,$0c
		dc.b		'  '
		dcb.b		29,$08
		dc.b		$08,$08,0
cr_1:		dcb.b		28,$08
		dc.b		0
cr_2:		dcb.b		31,$08
		dc.b		0
usmsg:	dc.b	'Text color changer v1.03.01 Copyright 1992,94 by Tsunami',$0d,$0a
	dc.b	'usage: tcc [-option]',$0d,$0a
	dc.b	'	 -d   describe present values',$0d,$0a
	dc.b	'	 -D   describe present values (extend mode)',$0d,$0a
	dc.b	'	 -h   show this message',$0d,$0a
	dc.b	'	 -i   initialize',$0d,$0a
	dc.b	'	 -t   test',$0d,$0a
	dc.b	'	 -T   test (extend mode)',$0d,$0a,$0d,$0a
	dc.b	'       tcc [p0][,[p1][,[p2][,[p3][,[p4][,[p8]]]]]]',$0d,$0a,$0d,$0a
	dc.b	'       tcc -option [p0][,[p1][,[p2][,[p3][,[p4][,[p5][,[p6][,[p7]',$0d,$0a
	dc.b	'	     [,[p8][,[p9][,[pA][,[pB][,[pC][,[pD][,[pE][,[pF]]]]]]]]]]]]]]]]',$0d,$0a
	dc.b	'	 -C   change (extend mode)'
crlf:	dc.b	$0d,$0a,0
errmsg1:	dc.b		'parameter sł',$0d,$0a,0
errmsg2:	dc.b		'color code sł',$0d,$0a,0
errmsg3:	dc.b		'memory ܂',$0d,$0a,0
errmsg4:	dc.b		'Ή̉ mode ł',$0d,$0a,0

.even
.offset		0

tpalwork:	ds.l		16		*  text pallet work area
						*    (16 F)
tpalsh:		ds.l		16		*  text pallet ޔ area
						*    (16 F)
win_str:	ds.b		win_struct	*  window `
envbuff:	ds.b		256		*  buffer for _GETENV
htosbuff:	ds.b		5		*  buffer for htos
messhead:	ds.b		22+3		*  header of message
						*    (18+1+3+messheadp(EOT ))
worksize:

.bss

work:		ds.b		worksize

.even
.stack

		ds.b		1024*2
usersp:

.even
.end
